﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;

public partial class uploadpic : System.Web.UI.Page
{
    private string SavePath = @"c:\uploadfiles";
    private string UrlFilePath = "/UserHead/";
    protected void Page_Load(object sender, EventArgs e)
    {
        initPage();
    }

    private void initPage()
    {
        if (Request.InputStream.Length == 0)
        {
            //没有内容
            Response.Write("0");
            return;
        }

        //HttpPostedFile myFile = Request.Files[0];  

        string OldFileName = this.GetQueryString("oldfilename");
        string DirPath = GetDataPath();
        string RealSavePath = SavePath + "\\" + DirPath + "\\";
        string fileExt = "jpg";
        if (OldFileName != "")
        {
            fileExt = OldFileName.Substring(OldFileName.LastIndexOf(".") + 1);
        }
        string NewFileName = GetFileName(fileExt);
        System.Drawing.Image postImage = System.Drawing.Image.FromStream(Request.InputStream);
        try
        {
            if (!Directory.Exists(RealSavePath))
            {
                System.IO.Directory.CreateDirectory(RealSavePath);
            }

            MakeSmallImage(postImage, RealSavePath, NewFileName);

            Response.Write(UrlFilePath + DirPath + "/" + NewFileName);
        }
        catch (Exception ex)
        {
            Response.Write("-1");
        }




    }

    /// <summary>
    /// 生成缩微图
    /// </summary>
    /// <param name="p_PostFile"></param>
    /// <param name="p_SaveFileName">保存的文件名，包括目录地址</param>
    private void MakeSmallImage(System.Drawing.Image imageBase, string p_SavePath, string p_FileName)
    {
        try
        {
            System.Drawing.Bitmap bitmap_b = new System.Drawing.Bitmap(imageBase);

            //保存
            bitmap_b.Save(p_SavePath + "/" + p_FileName, System.Drawing.Imaging.ImageFormat.Jpeg);

        }
        catch (Exception ex)
        {
            throw new Exception(ex.ToString());
        }
    }

    public string GetFileName(string FileType)
    {
        System.Random Rd = new Random();
        double Rds = Rd.NextDouble();
        string nowTime = System.DateTime.Now.ToString();
        nowTime = nowTime.Replace(" ", "");
        nowTime = nowTime.Replace("-", "");
        nowTime = nowTime.Replace(":", "");
        nowTime = nowTime.Trim() + "_" + Rds.ToString().Replace(".", "").Substring(0, 4);
        nowTime = nowTime + "." + FileType.ToLower();
        return nowTime;
    }

    public string GetDataPath()
    {
        string nowTime = System.DateTime.Now.ToShortDateString().Trim();
        return nowTime;
    }

    #region 获取QueryString的值
    /// <summary>
    /// sumary:获取QueryString的值

    /// </summary>
    /// <param name="key">QueryString中字段的名称</param>
    /// <returns>
    /// 如果存在则返回QueryString中字段对应的值 如果不存在或异常，则返回空字符串
    /// </returns>
    public string GetQueryString(string key)
    {
        try
        {
            string value = string.Empty;
            if (HttpContext.Current.Request.QueryString[key] != null)
            {
                value = HttpContext.Current.Request.QueryString[key].ToString();
            }
            return value;
        }
        catch
        {
            return string.Empty;
        }
    }
    #endregion
}
